=begin EltenAppInfo
Name=Reaction measurement Game
Version=1.0
Author=grzezlo
=end EltenAppInfo

class SimpleGameSound
  def self.set_samples_dir(dir)
    @@samples_dir = dir
  end

  def initialize(name)
    @so = Sound.new(@@samples_dir + name + ".ogg")
    @so.volume = 0.8
  end

  def stop
    @so.stop if @so.playing
  end

  def play(direction)
    stop
    @so.position = 0
    @so.pan = direction
    @so.play
  end
end # class SimpleGameSound

class ReactionMeasurementGame < Program
  def main
    menu = Menu.new
    menu.option("New game") {
      game_play
    }
    menu.option("Exit") {
      finish
    }
    menu.show
  end

  def game_sleep(wait_time)
    wait_time = Time.now.to_f + wait_time
    stop = false
    while not stop and Time.now.to_f < wait_time
      loop_update
      stop = true if escape
    end
    return stop
  end

  def game_play
    SimpleGameSound.set_samples_dir(appfile)
    sound_bad = SimpleGameSound.new("bad")
    sound_good = SimpleGameSound.new("good")
    sound_computer = SimpleGameSound.new("computer")
    end_game = false
    rounds_count = 0
    correct_answers_count = 0
    time_sum = 0
    while not end_game
      rounds_count = rounds_count + 1
      alert("Round #{rounds_count}.")
      wait_time = rand() * 4
      wait_time = wait_time + 1
      end_game = game_sleep(wait_time)
      break if end_game
      computer_direction = rand(3) - 1
      sound_computer.play(computer_direction)
      reaction_time = Time.now.to_f
      user_direction = nil
      while not end_game and user_direction == nil
        loop_update
        if escape
          end_game = true
        elsif arrow_left
          user_direction = -1
        elsif arrow_up
          user_direction = 0
        elsif arrow_right
          user_direction = 1
        end
      end #wait for user direction
      reaction_time = Time.now.to_f - reaction_time
      sound_computer.stop
      break if end_game
      if computer_direction == user_direction
        correct_answers_count = correct_answers_count + 1
        time_sum = time_sum + reaction_time
        sound_good.play(user_direction)
        end_game = game_sleep(1)
      else
        sound_bad.play(user_direction)
        game_sleep(1)
        end_game = true
      end
    end #main while loop
    alert("Game ended.")
    if correct_answers_count > 0
      reaction_avg = time_sum / correct_answers_count
      reaction_avg = (reaction_avg * 1000).round
      alert("Reaction time: #{reaction_avg} ms, after #{correct_answers_count} correct answers.")
    else
      alert("No correct answers.")
    end
  end # game_play
end # class SimpleReactionGame
